#ifndef STARSSegment_h
#define STARSSegment_h

#include "interfaces/STARSTypes.h"

class STARS_Segment_t
{
	public:
		/* get start and end addresses */
		virtual STARS_ea_t get_startEA() = 0;
		virtual STARS_ea_t get_endEA() = 0;
		virtual std::size_t get_seg_size() = 0;

		/* figure out what kind of segment this is */
		virtual bool IsCodeSegment() = 0;
		virtual bool IsXternSegment() { return false; };
		virtual bool IsDataSegment() = 0;
		virtual bool IsCommonSegment() = 0;
		virtual bool IsBSSSegment() = 0;

		/* examine segment permissions */
		virtual bool IsReadableSegment() = 0;
		virtual bool IsWriteableSegment() = 0;

		/* returns the segments name in the given buffer*/
		virtual STARS_ssize_t GetSegmentName(char* name, int len) = 0;

		
};

#endif
